//No_NPL

var 
rd lambda C Lambda L i MC_c pi_c Pi_star a1_c a2_c disp_c Y_c I IQ Q K K_per A_ne A_i_p  W b_bar Y_ne Y_i Y NE INC eta Ex e_rate
rb lev mu_b nu_b m n NW r_diff rk g g_z ksi risk K_exc K_ratio p_z K_mis rend k_q;

varExo  e_a e_o e_nu e_ksi e_risk;
       
parameters gamma_i 
rho_o   
rho_i   
kappa_pi 
kappa_y  
eps_c    
MC_c_ss  
Gamma_c 
mu_c     
rho_xi  
rho_g                                 
omega                             
phi                               
betta                             
gamma                            
alpha                             
delta                             
csi                                   
aux1     
aux2    
H                                  
H_np                               
phi_ne 
delta_inc phi_inc  rk_rd   
 a_b    
 mu        
 zeta     
 lev_GK   
 theta_b   
 lambda_b  
 hh      
 sig      
 psi     g_s g_z_s K_ratio_1 K_ratio_2 K_ratio_3 K_ratio_4 K_par

 
;  


gamma_i  = 3.14;
rho_o    = 0.06;
rho_i    = 0.8;
kappa_pi = 3.1;
kappa_y  = 0;
eps_c    = 5;
Gamma_c  = 0.78;
mu_c     = 0;
rho_xi   = 0.66; 
rho_g    = 0;                              
omega    = 0.002;                           
phi      = 0.27600000;                            
betta    = 0.9925;                             
gamma    = 0.8;                             
alpha    = 0.33;                           
delta    = 0.025;                           
csi      = 6.1;                             
aux1     = csi*(1-gamma)/(csi*(1-gamma)-1); 
aux2     = csi/(csi*(1-gamma)-1);
H        = 0.025;                           
H_np     = 0.08;                            
phi_ne   = 0.05;  
delta_inc =   0.0075;
%--------------------------- Steady State Calibration

 rk_rd     =   0.0026;
 phi_inc   =   0.1139;
 delta_inc =   0.0075;
 a_b       =   1; 
 mu        =   0.0208;
 zeta      =    0.8614;
 lev_GK    =    4;   
 theta_b   =    0.9724; 
 lambda_b  =    0.3890;
 hh        =    0.815;
 sig       =    1;
 psi       =    2.2557;
 g_s       =   1.0025;
 g_z_s     =   g_s^(1-alpha*gamma);

 K_ratio_1  = (1/(csi*(1-gamma)-1));
 K_ratio_2  = (csi/(csi-1))^csi-1;
 K_ratio_3  = 1/(gamma*0.8)*(csi*(1-gamma)/(csi*(1-gamma)-1));
 K_ratio_4  = (csi/(csi-1))^((csi*(1-gamma)-1)/(1-gamma))-1; 
 K_par      = (alpha*gamma/(1-gamma+alpha*gamma))^(csi*(1-gamma+alpha*gamma))/(csi-gamma*csi-1);


model;


Exp(rd)       =   Exp(lambda)*Exp(g(+1))/(betta*Exp(lambda(+1)));

Exp(lambda)   =   (Exp(C)-hh*Exp(C(-1))/Exp(g))^(-sig)-betta*hh*(Exp(C(+1))*Exp(g)-hh*Exp(C))^(-sig);

Exp(C)        =   Exp(Y)-Exp(I)*(1+gamma_i/2*(Exp(I)*Exp(g)/Exp(I(-1))-g_s)^2*Exp(I))-Exp(INC)*phi_inc-Exp(NE)*phi_ne-mu*(Exp(Ex));

Exp(Lambda)   =   Exp(lambda)/(Exp(lambda(-1))*Exp(g));

Exp(W)        =   psi*Exp(L)^(phi)/Exp(lambda);

Exp(i)*exp(risk)       =    Exp(lambda)/Exp(lambda(+1))*1/betta*Exp(pi_c(+1))*Exp(g(+1));

Exp(a1_c)     =  Exp(Pi_star)*Exp(Y_c)+Gamma_c*betta*(Exp(Pi_star)/Exp(Pi_star(+1)))*(Exp(pi_c)^(mu_c)/Exp(pi_c(+1)))^(1-eps_c)*(Exp(lambda(+1))/Exp(lambda))*Exp(a1_c(+1));

Exp(a2_c)     =  Exp(MC_c)*Exp(Y_c)+Gamma_c*betta*(Exp(pi_c)^(mu_c)/Exp(pi_c(+1)))^(-eps_c)*(Exp(lambda(+1))/Exp(lambda))*Exp(a2_c(+1));

Exp(a1_c)     =  Exp(a2_c)*eps_c/(eps_c-1);

1             =  (1-Gamma_c)*Exp(Pi_star)^(1-eps_c)+Gamma_c*(((Exp(pi_c(-1)))^(mu_c))/Exp(pi_c))^(1-eps_c);

Exp(disp_c)   =  (1-Gamma_c)*Exp(Pi_star)^(-eps_c)+Gamma_c*(((Exp(pi_c(-1)))^(mu_c))/Exp(pi_c))^(-eps_c)*Exp(disp_c(-1));

Exp(Y)        =  Exp(Y_c)/Exp(disp_c);

Exp(i)        =  (Exp(i(-1)))^rho_i*(1/betta*(Exp(pi_c))^(kappa_pi)*((eps_c-1)/(eps_c*Exp(MC_c)))^(kappa_y))^(1-rho_i)*Exp(-e_o);

Exp(K) = Exp(I) + Exp(ksi)*(1-delta)*Exp(K(-1))/Exp(g);

Exp(IQ)  = Exp(I)*Exp(Q);

Exp(K(-1))   =  Exp(K_per(-1))+exp(b_bar(-1))/exp(Q(-1))*(Exp(Ex));

Exp(K_per)   =  Exp(g(+1))*alpha*gamma*Exp(Y_ne(+1))*Exp(MC_c(+1))/(Exp(rk(+1))*Exp(Q)-Exp(ksi(+1))*Exp(Q(+1))*(1-delta))+Exp(b_bar)/(Exp(Q))*Exp(INC(+1));

Exp(Q)    = 1+ gamma_i/2*(Exp(I)*Exp(g)/Exp(I(-1))-g_s)^2+gamma_i/2*(Exp(I)*Exp(g)/Exp(I(-1))-g_s)*(Exp(I)*Exp(g)/Exp(I(-1)))-gamma_i/2*betta*Exp(Lambda(+1))*(Exp(I(+1))*Exp(g(+1))/Exp(I)-g_s)*(Exp(I(+1))*Exp(g(+1))/Exp(I))^2;

Exp(A_ne)     = ((phi_ne)/(1-gamma))^(1-gamma)*(((Exp(rk)*Exp(Q(-1))-Exp(ksi)*(1-delta)*Exp(Q))/(alpha*Exp(ksi)))^(alpha)*(Exp(W)/(1-alpha))^(1-alpha))^(gamma)/(Exp(MC_c)*gamma^(gamma));

Exp(A_i_p)    = ((phi_inc+(Exp(rk)*Exp(Q(-1))-Exp(ksi)*(1-delta)*Exp(Q))*Exp(b_bar(-1))/(Exp(Q(-1))*Exp(g)))/(1-gamma+alpha*gamma))^(1-gamma+alpha*gamma)*1/Exp(MC_c)*(Exp(g)*Exp(Q(-1))/(Exp(ksi)*Exp(b_bar(-1))))^(alpha*gamma)*(Exp(W)/((1-alpha)*gamma))^(gamma-gamma*alpha);

Exp(L)        = (1-alpha)*gamma*Exp(Y_c)*Exp(MC_c)/Exp(W);

Exp(Y_ne)     = Exp(NE)*aux2*phi_ne;

Exp(NE)       = (zeta/Exp(A_ne))^(csi);

Exp(INC)     = Exp(eta(-1))*(Exp(A_i_p(-1))*(1-delta_inc)*g_z_s/(Exp(A_i_p)*Exp(g_z)))^(csi); 

Exp(eta)     = Exp(INC) + Exp(NE);

Exp(Ex)      =  (1-(Exp(A_i_p(-1))*(1-delta_inc)*g_z_s/(Exp(A_i_p)*Exp(g_z)))^(csi)); 

Exp(Y_c)     = Exp(Y_ne)+Exp(Y_i);

Exp(Y_i)     = csi*(1-(1-alpha)*gamma)/(csi*(1-(1-alpha)*gamma)-1)*((Exp(INC))*Exp(A_i_p)^(1/(1-(1-alpha)*gamma)))*((Exp(g)*Exp(Q(-1))/(Exp(b_bar(-1))*Exp(ksi)))^(-alpha*gamma)*(Exp(W)*Exp(MC_c)^(-1)/((1-alpha)*gamma))^(gamma*alpha-gamma))^(1/(1-(1-alpha)*gamma));

Exp(b_bar)/(Exp(g(+1))) = alpha/(Exp(rk(+1))-Exp(ksi(+1))*(1-delta)*Exp(Q(+1))/Exp(Q))*(Exp(MC_c(+1))*gamma*csi/(csi-1)*Exp(A_i_p(+1))*(Exp(ksi(+1))*alpha/(Exp(rk(+1))-Exp(ksi(+1))*(1-delta)*Exp(Q(+1))/Exp(Q)))^(alpha*gamma)*(Exp(W(+1))/(1-alpha))^(alpha*gamma-gamma))^(1/(1-gamma));

Exp(n)      =   ((Exp(rb) - Exp(rd(-1)))*Exp(lev(-1)) + Exp(rd(-1)));

Exp(m)      =     Exp(lev)/Exp(lev(-1))*Exp(n);

Exp(mu_b)   =   (1-theta_b)*betta*Exp(Lambda(+1))*(Exp(rb(+1))-Exp(rd))+betta*theta_b*Exp(Lambda(+1))*Exp(m(+1))*Exp(mu_b(+1));

Exp(nu_b)   =   (1-theta_b)*betta*Exp(Lambda(+1))*Exp(rd)+betta*theta_b*Exp(Lambda(+1))*Exp(n(+1))*Exp(nu_b(+1));

Exp(NW)     =    theta_b*Exp(n)*Exp(NW(-1))*Exp(-e_nu)+Exp(ksi)*omega*Exp(K(-1))*Exp(Q);

Exp(K)*Exp(Q)   = Exp(lev)*Exp(NW);

Exp(r_diff)     = Exp(rb(+1))/Exp(rd);

Exp(lev)        =   Exp(nu_b)/(lambda_b-Exp(mu_b));

Exp(rb)*Exp(K(-1))*Exp(Q(-1))   = Exp(rk)*Exp(K_per(-1))*Exp(Q(-1))+(exp(b_bar(-1))*(exp(rk))-mu)*Exp(Ex);

g_z     = log(g_z_s)+e_a; 

g       = g_z*1/(1-alpha*gamma);

ksi = rho_xi*ksi(-1)-e_ksi;

Exp(e_rate) = Exp(NE)/Exp(eta);

exp(K_ratio) = K_ratio_1/(K_ratio_2+1/(gamma*exp(MC_c))*(csi*(1-gamma)/(csi*(1-gamma)-1))*K_ratio_4);

exp(p_z)     = (((exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))/(alpha*exp(ksi)))^(alpha)*(exp(W)/(1-alpha))^(1-alpha));

exp(K_exc)   =  (exp(b_bar(-1))/(exp(Q)*exp(g)))^(1-csi+gamma*csi)*K_ratio_1*(((exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))/(alpha*exp(ksi)))^(gamma-1)*gamma*exp(MC_c)*exp(A_i_p)*(1-delta_inc)/exp(p_z)^gamma)^csi;

exp(K_mis)   =  K_par*(1+phi_inc/((exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))*exp(b_bar(-1))/(exp(Q(-1))*exp(g))))^(csi*(1-gamma+alpha*gamma));

risk = 0.9*risk(-1)+e_risk;

exp(rend) = exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q);

exp(k_q) = exp(b_bar(-1))/exp(Q(-1));

end;

initval;
rd      =  0.01;
lambda  =  -0.7788;
C       =  0.8109;
Lambda  =  -0.0025;
L       =  -1.1087;
i       =  0.0100; 
MC_c    =  -0.2231;
pi_c    =  0;
Pi_star =  0;
a1_c    =  2.5122;
a2_c    =  2.2891;
disp_c  =  0;
Y_c     =  1.0243;
I       =  -0.8399;
IQ      =  -0.8399;
Q       =  0;
K       =  2.7561;
K_per   =  2.6466;
A_ne    =  0.4556;
A_i_p   =  0.7126;
W       =  1.2862;
b_bar   =  2.7437;
Y_ne    =  -3.3622;
Y_i     =  1.0118;
Y       =  1.0243;
NE      =  -3.6889;
INC     =  -0.0253;
eta     =  0;
Ex      =  -3.6889;
rb      =  0.0125;
lev     =  1.3863;
mu_b    =  -5.5640; 
nu_b    =  0.4323;
m       =  0.0199;
n       =  0.0199;
NW      =  1.3698;
r_diff  =  -5.9863;
rk      =  0.0126;
g       =  0.0025;
g_z     =  0.0018;
ksi     =  0;
e_rate  =  -3.6889;
K_mis   =  0.4219;
K_exc   =  3.0516;
p_z     =  0.4140;
K_ratio =  0.1616;
rend    =  -3.2787;
k_q     =  2.7437;

end;

%check;
steady;

shocks;
var e_a; stderr 0.05;
var e_nu; stderr 0.05;
var e_ksi; stderr 0.05;
var e_o; stderr 0.05;
var e_risk; stderr 0.001;
end;
%stoch_simul (order=1, irf=60) rend rk Q;
stoch_simul (order=1, irf=600, nograph);

    