var 
rd lambda C Lambda L i
MC_c pi_c Pi_star a1_c a2_c disp_c Y_c  
I IQ Q K K_per 
A_ne A_i_p A_i_np W PI_np b_bar Y_ne Y_np Y_i Y_i_p
Y NE INC   INC_np eta Ex e_rate
rb lev mu_b nu_b m n NW r_diff rk NPL_share NP_rate INC_p
g g_z ksi
A1 A2 beta_v Y_net mu_v
;

varexo e_b e_a e_o e_nu e_ksi e_mu ;
       
parameters r_diff_ss g_s g_z_s nu_ss MC_c_ss pi_c_ss 
Pi_star_ss a1_c_ss a2_c_ss i_ss hh sig b delta  K_per_ss  
kh rho_xi rho_g omega lambda_b theta_b  phi betta gamma alpha  csi    
aux1 aux2 psi zeta  mu H H_np phi_ne phi_inc eps_c Gamma_c rend_ss hh
mu_c rho_i kappa_y kappa_pi rho_o gamma_i delta_inc  K_par  K_ratio_1 K_ratio_2 K_ratio_4;

gamma_i  = 3.14;
rho_o    = 0.06;
rho_i    = 0.8;
kappa_pi = 3.1;
kappa_y  = 0;
eps_c    = 5;
MC_c_ss  = (eps_c-1)/eps_c;
Gamma_c  = 0.78;
mu_c     = 0;
rho_xi   = 0.66; 
rho_g    = 0;                              
omega    = 0.002;                           
phi      = 0.27600000;                            
betta    = 0.9925;                             
gamma    = 0.8;                             
alpha    = 0.33;                           
delta    = 0.025;                           
csi      = 6.1;                             
aux1     = csi*(1-gamma)/(csi*(1-gamma)-1); 
aux2     = csi/(csi*(1-gamma)-1);
H        = 0.025;                           
H_np     = 0.08;                            
phi_ne   = 0.05;  

%--------------------------- Steady State Calibration

 g_s       =   1.0025;
 g_z_s     =   g_s^(1-alpha*gamma);
 rk_rd     =   0.0026;
 phi_inc   =   phi_ne*2.277;
 delta_inc =   1-(1-H)^(1/csi);
  mu       =   0.0208;
 zeta      =    0.8614;
 theta_b   =    0.9724; 
 lambda_b  =    0.3890;
 hh        =    0.815;
 sig       =    1;
 psi       =   2.2557;


 model;

 
exp(rd)       =   exp(lambda)*exp(g(+1))/(exp(beta_v)*exp(lambda(+1)));

exp(lambda)   =   (exp(C)-hh*exp(C(-1))/exp(g))^(-sig)-exp(beta_v)*hh*(exp(C(+1))*exp(g)-hh*exp(C))^(-sig);

exp(C)        =   exp(Y)-exp(I)*(1+gamma_i/2*(exp(I)*exp(g)/exp(I(-1))-g_s)^2*exp(I))-(exp(INC)-exp(INC_np))*phi_inc-exp(NE)*phi_ne-exp(mu_v)*exp(Ex);

exp(Lambda)   =   exp(lambda)/(exp(lambda(-1))*exp(g));

exp(W)        =   psi*exp(L)^(phi)/exp(lambda);

exp(i)        =   exp(lambda)/exp(lambda(+1))*1/exp(beta_v)*exp(pi_c(+1))*exp(g(+1));

exp(a1_c)     =  exp(Pi_star)*exp(Y_c)+Gamma_c*exp(beta_v)*(exp(Pi_star)/exp(Pi_star(+1)))*(exp(pi_c)^(mu_c)/exp(pi_c(+1)))^(1-eps_c)*(exp(lambda(+1))/exp(lambda))*exp(a1_c(+1));

exp(a2_c)     =  exp(MC_c)*exp(Y_c)+Gamma_c*exp(beta_v)*(exp(pi_c)^(mu_c)/exp(pi_c(+1)))^(-eps_c)*(exp(lambda(+1))/exp(lambda))*exp(a2_c(+1));

exp(a1_c)     =  exp(a2_c)*eps_c/(eps_c-1);

1             =  (1-Gamma_c)*exp(Pi_star)^(1-eps_c)+Gamma_c*(((exp(pi_c(-1)))^(mu_c))/exp(pi_c))^(1-eps_c);

exp(disp_c)   =  (1-Gamma_c)*exp(Pi_star)^(-eps_c)+Gamma_c*(((exp(pi_c(-1)))^(mu_c))/exp(pi_c))^(-eps_c)*exp(disp_c(-1));

exp(Y)        =  exp(Y_c)/exp(disp_c);

exp(i)        =  (exp(i(-1)))^rho_i*(1/exp(beta_v)*(exp(pi_c))^(kappa_pi)*((eps_c-1)/(eps_c*exp(MC_c)))^(kappa_y))^(1-rho_i)*exp(-e_o);

exp(K) = exp(I) + exp(ksi)*(1-delta)*exp(K(-1))/exp(g);

exp(IQ)  = exp(I)*exp(Q);

exp(K(-1))   =  exp(K_per(-1))+exp(b_bar(-1))/(exp(Q(-1)))*(exp(INC_np)+exp(Ex));

exp(K_per)   =  exp(g(+1))*alpha*gamma*exp(Y_ne(+1))*exp(MC_c(+1))/(exp(rk(+1))*exp(Q)-exp(ksi(+1))*exp(Q(+1))*(1-delta))+exp(b_bar)/(exp(Q))*(exp(INC(+1))-exp(INC_np(+1)));

exp(Q)    = 1+ gamma_i/2*(exp(I)*exp(g)/exp(I(-1))-g_s)^2+gamma_i/2*(exp(I)*exp(g)/exp(I(-1))-g_s)*(exp(I)*exp(g)/exp(I(-1)))-gamma_i/2*exp(beta_v)*exp(Lambda(+1))*(exp(I(+1))*exp(g(+1))/exp(I)-g_s)*(exp(I(+1))*exp(g(+1))/exp(I))^2;

exp(A1)      = ((phi_inc+(exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))*exp(b_bar(-1))/(exp(Q(-1))*exp(g)))/(1-gamma+alpha*gamma))^(1-gamma+alpha*gamma);

exp(A2)      = 1/exp(MC_c)*(exp(g)*exp(Q(-1))/(exp(ksi)*exp(b_bar(-1))))^(alpha*gamma)*(exp(W)/((1-alpha)*gamma))^(gamma-gamma*alpha);

exp(A_ne)     = ((phi_ne)/(1-gamma))^(1-gamma)*(((exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))/(alpha*exp(ksi)))^(alpha)*(exp(W)/(1-alpha))^(1-alpha))^(gamma)/(exp(MC_c)*gamma^(gamma));

exp(A_i_p)    = ((phi_inc+(exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))*exp(b_bar(-1))/(exp(Q(-1))*exp(g)))/(1-gamma+alpha*gamma))^(1-gamma+alpha*gamma)*1/exp(MC_c)*(exp(g)*exp(Q(-1))/(exp(ksi)*exp(b_bar(-1))))^(alpha*gamma)*(exp(W)/((1-alpha)*gamma))^(gamma-gamma*alpha);

exp(A_i_np)   = ((phi_inc-exp(mu_v)+(exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))*exp(b_bar(-1))/(exp(Q(-1))*exp(g)))/(1-gamma+alpha*gamma))^(1-gamma+alpha*gamma)/exp(MC_c)*(exp(g)*exp(Q(-1))/(exp(ksi)*exp(b_bar(-1))))^(alpha*gamma)*(exp(W)/((1-alpha)*gamma))^(gamma-gamma*alpha);

exp(L)        = (1-alpha)*gamma*exp(Y_c)*exp(MC_c)/exp(W);

exp(Y_ne)     = exp(NE)*aux2*phi_ne;

exp(Y_i_p)    = csi*(1-(1-alpha)*gamma)/(csi*(1-(1-alpha)*gamma)-1)*((exp(INC)-exp(INC_np))*exp(A_i_p)^(1/(1-(1-alpha)*gamma)))*((exp(g)*exp(Q(-1))/(exp(b_bar(-1))*exp(ksi)))^(-alpha*gamma)*(exp(W)*exp(MC_c)^(-1)/((1-alpha)*gamma))^(gamma*alpha-gamma))^(1/(1-(1-alpha)*gamma));%26

exp(Y_np)     = csi*(1-(1-alpha)*gamma)/(csi*(1-(1-alpha)*gamma)-1)*(exp(INC)*exp(A_i_np)^(1/(1-(1-alpha)*gamma))-(exp(INC)-exp(INC_np))*exp(A_i_p)^(1/(1-(1-alpha)*gamma)))*((exp(g)*exp(Q(-1))/(exp(b_bar(-1))*exp(ksi)))^(-alpha*gamma)*(exp(W)*exp(MC_c)^(-1)/((1-alpha)*gamma))^(gamma*alpha-gamma))^(1/(1-(1-alpha)*gamma));

exp(NE)       = (zeta/exp(A_ne))^(csi);

exp(INC)      = exp(eta(-1))*(exp(A_i_np(-1))*(1-delta_inc)*g_z_s/(exp(A_i_np)*exp(g_z)))^(csi); 

exp(INC_np)  = exp(eta(-1))*((exp(A_i_np(-1))*(1-delta_inc)*g_z_s/(exp(A_i_np)*exp(g_z)))^(csi)-(exp(A_i_np(-1))*g_z_s*(1-delta_inc)/(exp(A_i_p)*exp(g_z)))^(csi)); 

exp(eta)     = exp(INC) + exp(NE);

exp(Ex)      = (1-(exp(A_i_np(-1))*(1-delta_inc)*g_z_s/(exp(A_i_np)*exp(g_z)))^(csi)); 

exp(Y_c)     = exp(Y_ne)+exp(Y_i);

exp(Y_i)     = exp(Y_i_p)+exp(Y_np);

exp(b_bar)/(exp(g(+1))) = alpha/(exp(rk(+1))-exp(ksi(+1))*(1-delta)*exp(Q(+1))/exp(Q))*(exp(MC_c(+1))*gamma*csi/(csi-1)*exp(A_i_p(+1))*(exp(ksi(+1))*alpha/(exp(rk(+1))-exp(ksi(+1))*(1-delta)*exp(Q(+1))/exp(Q)))^(alpha*gamma)*(exp(W(+1))/(1-alpha))^(alpha*gamma-gamma))^(1/(1-gamma));

exp(PI_np)   =    exp(MC_c)*exp(Y_np)*(1-(1-alpha)*gamma)-(phi_inc-exp(ksi)*(1-delta)*exp(Q)*exp(b_bar(-1))/(exp(Q(-1))*exp(g)))*exp(INC_np);

exp(n)      =     ((exp(rb) - exp(rd(-1)))*exp(lev(-1)) + exp(rd(-1)));

exp(m)      =     exp(lev)/exp(lev(-1))*exp(n);

exp(mu_b)   =     (1-theta_b)*exp(beta_v)*exp(Lambda(+1))*(exp(rb(+1))-exp(rd))+exp(beta_v)*theta_b*exp(Lambda(+1))*exp(m(+1))*exp(mu_b(+1));

exp(nu_b)   =    (1-theta_b)*exp(beta_v)*exp(Lambda(+1))*exp(rd)+exp(beta_v)*theta_b*exp(Lambda(+1))*exp(n(+1))*exp(nu_b(+1));

exp(NW)     =    theta_b*exp(n)*exp(NW(-1))*exp(-e_nu)+exp(ksi)*omega*exp(K(-1))*exp(Q);

exp(K)*exp(Q)   = exp(lev)*exp(NW);

exp(r_diff)     = exp(rb(+1))/exp(rd);

exp(lev)        =   exp(nu_b)/(lambda_b-exp(mu_b));

exp(rb)*exp(K(-1))*exp(Q(-1))   = exp(rk)*exp(K_per(-1))*exp(Q(-1))+exp(g)*exp(PI_np)+(exp(rk)*exp(b_bar(-1))-(exp(mu_v)))*exp(Ex);

g_z     = log(g_z_s)+e_a; 

g       = g_z*1/(1-alpha*gamma);

ksi = rho_xi*ksi(-1)-e_ksi;

exp(e_rate) = ((exp(NE)/exp(eta)));

exp(NPL_share) = exp(b_bar(-1))/exp(g)*exp(INC_np)/exp(K(-1));

exp(NP_rate)  = exp(INC_np)/exp(eta);

exp(beta_v) = exp(beta_v(-1))+e_b;

exp(Y_net) = exp(I) + exp(C);

exp(INC_p) = exp(INC)-exp(INC_np);

mu_v     = mu_v(-1)*0.9+log(mu)*0.1+e_mu;
end;

initval;

rd        	=	 0.0100336;
lambda    	=	 -0.77877;
C         	=	 0.810885;
Lambda    	=	 -0.00249688;
L         	=	 -1.10853;
i         	=	 0.0112226;
MC_c      	=	 -0.223056;
pi_c      	=	 0;
Pi_star   	=	 0;
a1_c      	=	 2.533;
a2_c      	=	 2.30986;
disp_c    	=	 0;
Y_c       	=	 1.02441;
I         	=	 -0.839997;
IQ        	=	 -0.839997;
Q         	=	 0;
K         	=	 2.75607;
K_per     	=	 2.64659;
A_ne      	=	 0.455557;
A_i_p     	=	 0.712616;
A_i_np    	=	 0.698581;
W         	=	 1.28626;
PI_np     	=	 0.227322;
b_bar     	=	 2.74347;
Y_ne      	=	 -3.36204;
Y_np      	=	 -1.90946;
Y_i       	=	 1.01189;
Y_i_p     	=	 0.956522;
Y         	=	 1.02435;
NE        	=	 -3.68873;
INC       	=	 -0.025167;
INC_np    	=	 -2.52558;
eta       	=	 0;
Ex          =	 -3.68888;
e_rate    	=	 -3.68888;
rb        	=	 0.0125177;
lev       	=	 1.38597;
mu_b      	=	 -5.56463;
nu_b      	=	 0.431961;
m         	=	 0.0199301;
n         	=	 0.0199301;
NW        	=	 1.3701;
r_diff    	=	 0.00248414;
rk        	=	 0.0126037;
NPL_share 	=	 -2.54068;
NP_rate   	=	 -2.52573;
INC_p     	=	 -0.110781;
g         	=	 0.00249688;
g_z       	=	 0.0018377;
ksi       	=	 0;
A1        	=	 0.189481;
A2        	=	 0.523135;
beta_v    	=	 -0.00753669;
Y_net     	=	 0.986417;
mu_v      	=	 log(mu);
end;


steady;

shocks;
var e_mu; stderr 1.2;
corr e_ksi, e_mu = 0.9;
var e_b; stderr 0.001;
var e_a; stderr 0.05;
var e_nu; stderr 0.05;
var e_ksi; stderr 0.05;
var e_o; stderr 0.05;
end;
stoch_simul (order=1, irf=600, nograph);

    