var  
rd lambda C Lambda L i
MC_c pi_c Pi_star a1_c a2_c disp_c Y_c  
I IQ Q K K_per 
A_ne A_i_p A_i_np W PI_np b_bar Y_ne Y_np Y_i Y_i_p
Y NE INC   INC_np eta Ex e_rate
rb lev mu_b nu_b m n NW r_diff rk NPL_share NP_rate INC_p
g g_z ksi
A1 A2 beta_v Y_net lambda_var qe lev_c r_diff_npl
CB
;

varexo e_b e_a e_o e_nu e_ksi e_qe;
       
parameters r_diff_npl_ss r_diff_ss rk_ss rd_ss lambda_ss Lambda_ss C_ss I_ss
A_ne_ss A_i_ss A_np_ss W_ss K_ss k_bar_ss L_ss Y_ne_ss Y_i_ss 
Y_np_ss Y_p_ss Y_ss NE_ss INC_ss NP_ss eta_ss rb_ss lev_ss mu_b_ss   
nu_b_ss m_ss n_ss NW_ss PI_np_ss g_s g_z_s nu_ss MC_c_ss pi_c_ss 
Pi_star_ss a1_c_ss a2_c_ss i_ss hh sig b delta  K_per_ss  
kh rho_xi rho_g omega lambda_b theta_b  phi betta gamma alpha  csi    
aux1 aux2 psi zeta  mu H H_np phi_ne phi_inc eps_c Gamma_c
mu_c rho_i kappa_y kappa_pi rho_o gamma_i delta_inc NPL_share_ss Y_net_ss Ex_ss;

gamma_i  = 3.14;
rho_o    = 0.06;
rho_i    = 0.8;
kappa_pi = 3.1;
kappa_y  = 0;
eps_c    = 5;
MC_c_ss  = (eps_c-1)/eps_c;
Gamma_c  = 0.78;
mu_c     = 0;
rho_xi   = 0.66; 
rho_g    = 0;                              
omega    = 0.002;                           
phi      = 0.27600000;                            
betta    = 0.9925;                             
gamma    = 0.8;                             
alpha    = 0.33;                           
delta    = 0.025;                           
csi      = 6.1;                             
aux1     = csi*(1-gamma)/(csi*(1-gamma)-1); 
aux2     = csi/(csi*(1-gamma)-1);
H        = 0.025;                           
H_np     = 0.08;                            
phi_ne   = 0.05;  

%--------------------------- Steady State Calibration

 g_s       =   1.0025;
 g_z_s     =   g_s^(1-alpha*gamma);
 NE_ss     =   H;
 eta_ss    =   1;
 NP_ss     =   H_np;
 INC_ss    =   (1-H);
 INC_p_ss   =  (1-H-H_np);
 Lambda_ss =   1/g_s;
 rd_ss     =   1/(Lambda_ss*betta);
 rk_rd     =   0.0026;
 rk_ss     =   rd_ss+rk_rd;
 phi_inc   =   phi_ne*2.277;
 delta_inc =   1-(1-NE_ss)^(1/csi);
 k_bar_ss  =   g_s*alpha*gamma/(rk_ss-1+delta)*(phi_inc)*(csi/(csi-1))^(1/(1-gamma+alpha*gamma))/(1-gamma+alpha*gamma-alpha*gamma*(csi/(csi-1))^(1/(1-gamma+alpha*gamma)));
 mu       =   (rk_ss-1+delta)*k_bar_ss/g_s+phi_inc-(phi_inc+(rk_ss-1+delta)*k_bar_ss/g_s)*(INC_p_ss/(1-delta_inc)^csi)^(1/(csi*(1-gamma+alpha*gamma)));
 L_ss      =    0.33;
 Y_ne_ss   =    NE_ss*aux2*phi_ne;
 Y_p_ss    =    csi*(1-(1-alpha)*gamma)/(csi*(1-(1-alpha)*gamma)-1)*1/MC_c_ss*(INC_p_ss)*(phi_inc+(rk_ss-1+delta)*k_bar_ss/g_s)/(1-gamma+alpha*gamma);
 Y_np_ss   =    csi*(1-(1-alpha)*gamma)/(csi*(1-(1-alpha)*gamma)-1)*1/MC_c_ss*(INC_ss*(1-NP_ss/INC_ss)^(1/(csi*(1-gamma+alpha*gamma)))-(INC_ss-NP_ss))*(phi_inc+(rk_ss-1+delta)*k_bar_ss/g_s)/(1-gamma+alpha*gamma);
 Y_i_ss    =    Y_np_ss+Y_p_ss;
 Y_ss      =    Y_ne_ss+ Y_i_ss;
 W_ss      =   (1-alpha)*Y_ss*MC_c_ss*gamma/L_ss;
 A_ne_ss   =   ((phi_ne)/(1-gamma))^(1-gamma)*(((rk_ss-1+delta)/alpha)^(alpha)*(W_ss/(1-alpha))^(1-alpha))^(gamma)/(MC_c_ss*gamma^(gamma));
 A_np_ss   =   ((phi_inc-mu+(rk_ss-(1-delta))*k_bar_ss/g_s)/(1-gamma+alpha*gamma))^(1-gamma+alpha*gamma)/MC_c_ss*(g_s/k_bar_ss)^(alpha*gamma)*(W_ss/((1-alpha)*gamma))^(gamma-gamma*alpha);
 A_i_ss    =   ((phi_inc+(rk_ss-(1-delta))*k_bar_ss/g_s)/(1-gamma+alpha*gamma))^(1-gamma+alpha*gamma)/MC_c_ss*(g_s/k_bar_ss)^(alpha*gamma)*(W_ss/((1-alpha)*gamma))^(gamma-gamma*alpha);
 zeta      =    H^(1/csi)*A_ne_ss;
 K_ne_ss   =    (Y_ne_ss)*MC_c_ss*alpha*gamma/(rk_ss-1+delta)/NE_ss;
 K_per_ss  =    g_s*(Y_ne_ss)*MC_c_ss*alpha*gamma/(rk_ss-1+delta)+INC_p_ss*k_bar_ss;
 K_ss      =    K_per_ss+(NP_ss)*k_bar_ss+k_bar_ss*NE_ss;
 B_np_ss   =    NP_ss*k_bar_ss;
 PI_np_ss  =    (MC_c_ss*Y_np_ss*(1-(1-alpha)*gamma)-NP_ss*(phi_inc-k_bar_ss*(1-delta)/g_s));
 rb_ss     =    (K_per_ss*rk_ss+PI_np_ss*g_s+(k_bar_ss*rk_ss-mu)*NE_ss)/K_ss;
 lev_GK    =    4;     %per ottenere GK calibration
 theta_b   =    (1-lev_GK*omega)/(lev_GK*(rb_ss-rd_ss)+rd_ss); 
 lev_ss    =    (1-theta_b*rd_ss)/((theta_b*(rb_ss-rd_ss))+omega);
 n_ss      =    ((rb_ss - rd_ss)*lev_ss + rd_ss);
 m_ss      =     n_ss;
 mu_b_ss   =    (1-theta_b)*Lambda_ss*betta*(rb_ss-rd_ss)/(1-betta*Lambda_ss*theta_b*n_ss);
 nu_b_ss   =    (1-theta_b)*Lambda_ss*betta*rd_ss/(1-betta*Lambda_ss*theta_b*n_ss);
 lambda_b  =    (nu_b_ss+mu_b_ss*lev_ss)/lev_ss;
 NW_ss     =     K_ss/(lev_ss);
 I_ss      =    (1-(1-delta)/g_s)*K_ss;
 C_ss      =    (Y_ss)-I_ss-(INC_p_ss)*phi_inc-(NE_ss)*phi_ne-(NE_ss)*mu;
 hh        =    0.815;
 sig       =    1;
 lambda_ss =   (C_ss-hh*C_ss/g_s)^(-sig)-betta*hh*(C_ss*g_s-hh*C_ss)^(-sig);
 psi       =    W_ss*lambda_ss/L_ss^phi;
 r_diff_ss =    rb_ss-rd_ss;
 pi_c_ss   =    1;
 Pi_star_ss=    1;
 a1_c_ss   =    Y_ss/(1-Gamma_c*betta);
 a2_c_ss   =    MC_c_ss*Y_ss/(1-Gamma_c*betta);
 i_ss      =    rd_ss;
 A1_ss      = ((phi_inc+(rk_ss-(1-delta))*k_bar_ss/g_s)/(1-gamma+alpha*gamma))^(1-gamma+alpha*gamma);
 A2_ss      = 1/MC_c_ss*(g_s/k_bar_ss)^(alpha*gamma)*(W_ss/((1-alpha)*gamma))^(gamma-gamma*alpha);
 NPL_share_ss = k_bar_ss/g_s*NP_ss/K_ss;
 Y_net_ss   = C_ss+I_ss; 
 Ex_ss       = 1-(1-delta_inc)^csi;
 r_diff_npl_ss  = PI_np_ss*g_s/(k_bar_ss*H_np)-rd_ss;
 
 model;
 
exp(rd)       =   exp(lambda)*exp(g(+1))/(exp(beta_v)*exp(lambda(+1)));

exp(lambda)   =   (exp(C)-hh*exp(C(-1))/exp(g))^(-sig)-exp(beta_v)*hh*(exp(C(+1))*exp(g)-hh*exp(C))^(-sig);

exp(C)        =   exp(Y)-exp(I)*(1+gamma_i/2*(exp(I)*exp(g)/exp(I(-1))-g_s)^2*exp(I))-(exp(INC)-exp(INC_np))*phi_inc-exp(NE)*phi_ne-mu*exp(Ex);

exp(Lambda)   =   exp(lambda)/(exp(lambda(-1))*exp(g));

exp(W)        =   psi*exp(L)^(phi)/exp(lambda);

exp(i)        =   exp(lambda)/exp(lambda(+1))*1/exp(beta_v)*exp(pi_c(+1))*exp(g(+1));

exp(a1_c)     =  exp(Pi_star)*exp(Y_c)+Gamma_c*exp(beta_v)*(exp(Pi_star)/exp(Pi_star(+1)))*(exp(pi_c)^(mu_c)/exp(pi_c(+1)))^(1-eps_c)*(exp(lambda(+1))/exp(lambda))*exp(a1_c(+1));

exp(a2_c)     =  exp(MC_c)*exp(Y_c)+Gamma_c*exp(beta_v)*(exp(pi_c)^(mu_c)/exp(pi_c(+1)))^(-eps_c)*(exp(lambda(+1))/exp(lambda))*exp(a2_c(+1));

exp(a1_c)     =  exp(a2_c)*eps_c/(eps_c-1);

1             =  (1-Gamma_c)*exp(Pi_star)^(1-eps_c)+Gamma_c*(((exp(pi_c(-1)))^(mu_c))/exp(pi_c))^(1-eps_c);

exp(disp_c)   =  (1-Gamma_c)*exp(Pi_star)^(-eps_c)+Gamma_c*(((exp(pi_c(-1)))^(mu_c))/exp(pi_c))^(-eps_c)*exp(disp_c(-1));

exp(Y)        =  exp(Y_c)/exp(disp_c);

exp(i)        =  (exp(i(-1)))^rho_i*(1/exp(beta_v)*(exp(pi_c))^(kappa_pi)*((eps_c-1)/(eps_c*exp(MC_c)))^(kappa_y))^(1-rho_i)*exp(-e_o);

exp(K) = exp(I) + exp(ksi)*(1-delta)*exp(K(-1))/exp(g);

exp(IQ)  = exp(I)*exp(Q);

exp(K(-1))   =  exp(K_per(-1))+exp(b_bar(-1))/(exp(Q(-1)))*(exp(INC_np)+exp(Ex));

exp(K_per)   =  exp(g(+1))*alpha*gamma*exp(Y_ne(+1))*exp(MC_c(+1))/(exp(rk(+1))*exp(Q)-exp(ksi(+1))*exp(Q(+1))*(1-delta))+exp(b_bar)/(exp(Q))*(exp(INC(+1))-exp(INC_np(+1)));

exp(Q)    = 1+ gamma_i/2*(exp(I)*exp(g)/exp(I(-1))-g_s)^2+gamma_i/2*(exp(I)*exp(g)/exp(I(-1))-g_s)*(exp(I)*exp(g)/exp(I(-1)))-gamma_i/2*exp(beta_v)*exp(Lambda(+1))*(exp(I(+1))*exp(g(+1))/exp(I)-g_s)*(exp(I(+1))*exp(g(+1))/exp(I))^2;

exp(A1)      = ((phi_inc+(exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))*exp(b_bar(-1))/(exp(Q(-1))*exp(g)))/(1-gamma+alpha*gamma))^(1-gamma+alpha*gamma);

exp(A2)      = 1/exp(MC_c)*(exp(g)*exp(Q(-1))/(exp(ksi)*exp(b_bar(-1))))^(alpha*gamma)*(exp(W)/((1-alpha)*gamma))^(gamma-gamma*alpha);

exp(A_ne)     = ((phi_ne)/(1-gamma))^(1-gamma)*(((exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))/(alpha*exp(ksi)))^(alpha)*(exp(W)/(1-alpha))^(1-alpha))^(gamma)/(exp(MC_c)*gamma^(gamma));

exp(A_i_p)    = ((phi_inc+(exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))*exp(b_bar(-1))/(exp(Q(-1))*exp(g)))/(1-gamma+alpha*gamma))^(1-gamma+alpha*gamma)*1/exp(MC_c)*(exp(g)*exp(Q(-1))/(exp(ksi)*exp(b_bar(-1))))^(alpha*gamma)*(exp(W)/((1-alpha)*gamma))^(gamma-gamma*alpha);

exp(A_i_np)   = ((phi_inc-mu+(exp(rk)*exp(Q(-1))-exp(ksi)*(1-delta)*exp(Q))*exp(b_bar(-1))/(exp(Q(-1))*exp(g)))/(1-gamma+alpha*gamma))^(1-gamma+alpha*gamma)/exp(MC_c)*(exp(g)*exp(Q(-1))/(exp(ksi)*exp(b_bar(-1))))^(alpha*gamma)*(exp(W)/((1-alpha)*gamma))^(gamma-gamma*alpha);

exp(L)        = (1-alpha)*gamma*exp(Y_c)*exp(MC_c)/exp(W);

exp(Y_ne)     = exp(NE)*aux2*phi_ne;

exp(Y_i_p)    = csi*(1-(1-alpha)*gamma)/(csi*(1-(1-alpha)*gamma)-1)*((exp(INC)-exp(INC_np))*exp(A_i_p)^(1/(1-(1-alpha)*gamma)))*((exp(g)*exp(Q(-1))/(exp(b_bar(-1))*exp(ksi)))^(-alpha*gamma)*(exp(W)*exp(MC_c)^(-1)/((1-alpha)*gamma))^(gamma*alpha-gamma))^(1/(1-(1-alpha)*gamma));%26

exp(Y_np)     = csi*(1-(1-alpha)*gamma)/(csi*(1-(1-alpha)*gamma)-1)*(exp(INC)*exp(A_i_np)^(1/(1-(1-alpha)*gamma))-(exp(INC)-exp(INC_np))*exp(A_i_p)^(1/(1-(1-alpha)*gamma)))*((exp(g)*exp(Q(-1))/(exp(b_bar(-1))*exp(ksi)))^(-alpha*gamma)*(exp(W)*exp(MC_c)^(-1)/((1-alpha)*gamma))^(gamma*alpha-gamma))^(1/(1-(1-alpha)*gamma));

exp(NE)       = (zeta/exp(A_ne))^(csi);

exp(INC)      = exp(eta(-1))*(exp(A_i_np(-1))*(1-delta_inc)*g_z_s/(exp(A_i_np)*exp(g_z)))^(csi); 

exp(INC_np)  = exp(eta(-1))*((exp(A_i_np(-1))*(1-delta_inc)*g_z_s/(exp(A_i_np)*exp(g_z)))^(csi)-(exp(A_i_np(-1))*g_z_s*(1-delta_inc)/(exp(A_i_p)*exp(g_z)))^(csi)); 

exp(eta)     = exp(INC) + exp(NE);

exp(Ex)      = (1-(exp(A_i_np(-1))*(1-delta_inc)*g_z_s/(exp(A_i_np)*exp(g_z)))^(csi)); 

exp(Y_c)     = exp(Y_ne)+exp(Y_i);

exp(Y_i)     = exp(Y_i_p)+exp(Y_np);

exp(b_bar)/(exp(g(+1))) = alpha/(exp(rk(+1))-exp(ksi(+1))*(1-delta)*exp(Q(+1))/exp(Q))*(exp(MC_c(+1))*gamma*csi/(csi-1)*exp(A_i_p(+1))*(exp(ksi(+1))*alpha/(exp(rk(+1))-exp(ksi(+1))*(1-delta)*exp(Q(+1))/exp(Q)))^(alpha*gamma)*(exp(W(+1))/(1-alpha))^(alpha*gamma-gamma))^(1/(1-gamma));

exp(PI_np)   =    exp(MC_c)*exp(Y_np)*(1-(1-alpha)*gamma)-(phi_inc-exp(ksi)*(1-delta)*exp(Q)*exp(b_bar(-1))/(exp(Q(-1))*exp(g)))*exp(INC_np);

exp(n)      =     ((exp(rb) - exp(rd(-1)))*exp(lev(-1)) + exp(rd(-1)));

exp(m)      =     exp(lev)/exp(lev(-1))*exp(n);

exp(mu_b)   =     (1-theta_b)*exp(beta_v)*exp(Lambda(+1))*(exp(rb(+1))-exp(rd))+exp(beta_v)*theta_b*exp(Lambda(+1))*exp(m(+1))*exp(mu_b(+1));

exp(nu_b)   =    (1-theta_b)*exp(beta_v)*exp(Lambda(+1))*exp(rd)+exp(beta_v)*theta_b*exp(Lambda(+1))*exp(n(+1))*exp(nu_b(+1));

exp(NW)     =    theta_b*exp(n)*exp(NW(-1))*exp(-e_nu)+(1-qe)*exp(ksi)*omega*exp(K(-1))*exp(Q);

exp(K)*exp(Q)   = exp(lev_c)*exp(NW);

exp(r_diff)     = exp(rb(+1))/exp(rd);

exp(lev)        =   exp(nu_b)/(exp(lambda_var)-exp(mu_b));

exp(rb)*exp(K(-1))*exp(Q(-1))   = exp(rk)*exp(K_per(-1))*exp(Q(-1))+exp(g)*exp(PI_np)+(exp(rk)*exp(b_bar(-1))-(mu))*exp(Ex);

g_z     = log(g_z_s)+e_a; 

g       = g_z*1/(1-alpha*gamma);

ksi = 0.66*ksi(-1)-e_ksi;

exp(e_rate) = ((exp(NE)/exp(eta)));

exp(NPL_share) = exp(b_bar(-1))/exp(g)*exp(INC_np)/exp(K(-1));

exp(NP_rate)  = exp(INC_np)/exp(eta);

exp(beta_v) = exp(beta_v(-1))+e_b;

exp(Y_net) = exp(I) + exp(C);

exp(INC_p) = exp(INC)-exp(INC_np);

exp(lambda_var) = lambda_b+lambda_b*1.5*(exp(INC_np)-H_np);

exp(lev_c)  = exp(lev)/(1-qe);

exp(r_diff_npl) = exp(PI_np_ss)*exp(g)/exp(b_bar(-1))/exp(INC_np)-exp(rd);

qe          = 0.66*qe(-1)+100*(exp(r_diff)-1.0025)*0.34+e_qe;

CB          = (qe)*exp(K(-1));
end;

initval;

rd         =	0.00987611;
lambda     	=	 -0.780206;
C          	=	 0.811663;
Lambda     	=	 -0.00249688;
L          	=	 -1.10846;
i          	=	 0.0110651;
MC_c       	=	 -0.223059;
pi_c       	=	 0.00;
Pi_star    	=	 0.00;
a1_c       	=	 2.53508;
a2_c       	=	 2.31193;
disp_c     	=	0;
Y_c        	=	 1.02593;
I          	=	 -0.83461;
IQ         	=	 -0.83461;
Q          	=	 0;
K          	=	 2.76146;
K_per      	=	 2.65202;
A_ne       	=	 0.455308;
A_i_p      	=	 0.712367;
A_i_np     	=	 0.698332;
W          	=	 1.28771;
PI_np      	=	 0.232604;
b_bar      	=	 2.74737;
Y_ne       	=	 -3.36053;
Y_np       	=	 -1.90794;
Y_i        	=	 1.01341;
Y_i_p      	=	 0.958044;
Y          	=	 1.02587;
NE         	=	 -3.68721;
INC        	=	 -0.0236486;
INC_np     	=	 -2.52406;
eta        	=	 0.00;
Ex         	=	 -3.68888;
e_rate     	=	 -3.68888;
rb         	=	 0.012373;
lev        	=	 1.3919;
mu_b       	=	 -5.55348;
nu_b       	=	 0.437986;
m          	=	 0.0198821;
n          	=	 0.0198821;
NW         	=	 1.36955;
r_diff     	=	 0.00249688;
rk         	=	 0.0124586;
NPL_share  	=	 -2.54064;
NP_rate    	=	 -2.52573;
INC_p      	=	 -0.109262;
g          	=	 0.00249688;
g_z        	=	 0.0018377;
ksi        	=	 0;
A1         	=	 0.189481;
A2         	=	 0.522886;
beta_v     	=	 -0.00737923;
Y_net      	=	 0.987939;
lambda_var 	=	 -0.943912;
qe         	=	 0;
lev_c      	=	 1.3919;
r_diff_npl 	=	 0.589849;
CB         	=	 0;
end;

%check;
steady;

shocks;

var e_b; stderr 0.001;
var e_a; stderr 0.05;
var e_nu; stderr 0.05;
var e_ksi; stderr 0.05;
var e_o; stderr 0.05;
end;
%stoch_simul (order=1, irf=60) CB;
stoch_simul (order=1, irf=600, nograph);

    